/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2009
 * graycardinalster@gmail.com
 *
 */

#ifdef __linux

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <gclib/gclib.h>
#include <sys/wait.h>
#include <mod.h>
#include <head.h>
#include <dbg.h>

void cache_file (char * file, int adv)
{
	int fd;
	
	fd = open (file, O_RDONLY);
	if (fd < 0)
		return;

	Dposix_fadvise (fd, 0, fdsize (fd), adv);
	close (fd);
	return;
}

int cache_load ()
{
	DArray * files = ENV->d_files;
	for (int i = 0; i < files->get_size (); i++) 
		cache_file (files->get (i), POSIX_FADV_WILLNEED);
	return 0;
}

int cache_free ()
{
	DArray * files = ENV->d_files;
	for (int i = 0; i < files->get_size (); i++)
		cache_file (files->get (i), POSIX_FADV_DONTNEED);
	return 0;
}

#else
int cache_load ()
{
	return -1;
}

int cache_free ()
{
	return -1;
}
#endif


