/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2009
 * graycardinalster@gmail.com
 *
 */

#include <head.h>
#include <the_tt.h>
#include <cmds.h>

void bob_commands ()
{
	switch (ENV->sb_cmd) {
		case cmd_cgrep:
			cgrep::init ();
		case cmd_grep:
		case cmd_makectags:
		case cmd_call_tags:
			entry_point ();
			exit (0);

		case cmd_tree:
			if (!SB_FLGET (SB_FLRTREE))
				call_tree (ENV->d_files->get (0), 0);
			else
				reverse_calltree (ENV->d_files->get (0));
			exit (0);
		
		case cmd_indent:
			nogui_indent ();
			exit (0);		
		case cmd_replace:
			replace ();
			exit (0);
		case cmd_tags:
			tags (ENV->d_files, NULL);
			exit (0);		
		case cmd_files:
			files ();
			exit (0);
		case cmd_kinds:
			bob_kinds ();
			exit (0);
	}
}

void bob_commands2 ()
{
	int i;
	int n_files;

	n_files = ENV->d_files->get_size ();
	for (i = 0; i < n_files; i++) {
		switch (ENV->sb_cmd) {
			case cmd_file:
				flist_main (ENV->d_files->get (i));
				break;
			case cmd_the_tt:
				THE_TT::the_tt_main (ENV->d_files->get(i));	
				break;
			case cmd_give_structs:
				got_structs (ENV->d_files->get (i));	
				break;
		}
	}
}

void bob_commands_nofiles ()
{
	char d_buf[1024];
	
	if (ENV->d_files->get_size ())
		return;

	if (ENV->sb_cmd == cmd_the_tt) // THE_TT for stdin
		THE_TT::the_tt_main ((char *) "-");

	else if (ENV->sb_cmd == cmd_give_structs) {
		got_structs ((char *) "-");
		exit (0);

	} else if (ENV->sb_cmd == cmd_file) {

		while (fgets (d_buf, 1023, stdin)) {
			chomp (d_buf);
			switch (ENV->sb_cmd) {
				case cmd_file:
					flist_main (d_buf);
					break;
			}

		}

	}
	
}


